from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.SimpleAlias.config import *
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.CMFDynamicViewFTI.migrate import migrateFTIs

def install_cmfcpviews(self,out):
    """ Install Viewlets for CMFContentspanels"""
    try:
        cptool = getToolByName(self, 'portal_contentpanels', None)
        cptool.installActions(VIEWLETS)
        out.write('Installed viewlets for CMFContentPanels \n')
    except:
        out.write('No viewlets for CMFContentspanels installed \n')


def install(self):
    out = StringIO()
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)
    install_subskin(self, out, GLOBALS)

    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    #create the tool instance
    portal = getToolByName(self,'portal_url').getPortalObject()

    if not hasattr(self, 'simplealias_tool'):
        addTool = portal.manage_addProduct['SimpleAlias'].manage_addTool
        addTool(type='SimpleAlias tool')    
    
    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'Alias' not in types:
        types.append('Alias')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)    

    # create the action
    at=getToolByName(self, 'portal_actions')
        
    if 'paste_as_alias' not in [action.id for action in at.listActions()]:
        at.addAction('paste_as_alias','Paste as Alias','string:pasteAlias:method','folder/cb_dataValid','SimpleAlias: Add Alias','folder_buttons')

    install_cmfcpviews(self, out)
        
    print >> out, "Successfully installed %s." % PROJECTNAME
   
    return out.getvalue()
