from Globals import package_home
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
import os, os.path, sys
import content
from config import SKINS_DIR, GLOBALS, PROJECTNAME
from config import ADD_ALIAS_PERMISSION

# Module aliases - we don't always get it right on the first try, but and we
# can't move modules around because things are stored in the ZODB with the
# full module path. However, we can create aliases for backwards compatability.
sys.modules['Products.SimpleAlias.Alias'] = content.alias

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):
    import Alias

    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)
        
    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types, 
        permission         = ADD_ALIAS_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    from SimpleAliasTool import SimpleAliasTool
    utils.ToolInit(
        'SimpleAlias tool', 
        tools=(SimpleAliasTool,),  
        product_name='SimpleAlias', 
        icon='tool.gif', ).initialize(context)    